cakcmd <- function(s11, s10, s01, s00, r11, r10, r01, r00, u11, u10, u01, u00)
{   
 
  
  # stop criterion  source("F:\\cakcmd.r") cakcmd(224,1,18,1,38,32,6,35,31,24,21,219)
    
  delta <- 10^(-12)
  sqrtdelta <- sqrt(delta)
  
  # Confidence level of the confidence intervals
  
  conf <- 0.95
  alpha <- 1 - conf
  zalpha <- qnorm(1 - alpha / 2)
  
  n11 <- s11 + r11 + u11
  n10 <- s10 + r10 + u10
  n01 <- s01 + r01 + u01
  n00 <- s00 + r00 + u00
  
  n <- n11 + n10 + n01 + n00
  
  ss <- s11 + s10 + s01 + s00
  r <- r11 + r10 + r01 + r00
  u <- u11 + u10 + u01 + u00
  
  if (ss == 0 | r == 0) 
    {
      cat("\n")
      stop("There are many observed frequencies equal to zero. Introduces new values \n")
      cat("\n")
    }
    
  if (u == 0) 
    {
      cat("\n")
      stop("No missing data. Introduces new values \n")
      cat("\n")
    }  
  
  if (s11 < 0 | s10 < 0 | s01 < 0 | s00 < 0 | r11 < 0 | r10 < 0 | r01 < 0 | r00 < 0 | r11 < 0 | r10 < 0 | r01 < 0 | r00 < 0) 
    {
      cat("\n")
      stop("Any observed frequency can be negative. Introduces new values \n")
      cat("\n")
    }
    
  if (abs(s00 - trunc(s00)) > 0 | abs(s01 - trunc(s01)) > 0 | abs(s10 - trunc(s10)) > 0 | abs(s11 - trunc(s11)) > 0 | abs(r00 - trunc(r00)) > 0
     | abs(r01 - trunc(r01)) > 0 | abs(r10 - trunc(r10)) > 0 | abs(r11 - trunc(r11)) > 0 | abs(u00 - trunc(u00)) > 0  | abs(u01 - trunc(u01)) > 0
     | abs(u10 - trunc(u10)) > 0  | abs(u11 - trunc(u11)) > 0)
    {
      cat("\n")
      stop("Observed frequencies can not have decimals. Introduces new values \n")
      cat("\n")
    }
   
  
  # EM algorithm
  
  kappa10 <- vector()
  kappa11 <- vector()
  
  kappa20 <- vector()
  kappa21 <- vector()
  
  prev <- vector()
  
  cov1 <- vector()
  cov0 <- vector()
  
  y11 <- u11 / 2  
  y10 <- u10 / 2  
  y01 <- u01 / 2  
  y00 <- u00 / 2   
  y <- y11 + y10 + y01 + y00 
    
  ka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
  ka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
  
  ka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
  ka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
  
  p <- (ss + y) / n
  
  a1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
  a0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
       
  kappa10[1] <- ka10
  kappa11[1] <- ka11
  
  kappa20[1] <- ka20
  kappa21[1] <- ka21
  
  prev[1] <- p
  
  cov1[1] <- a1
  cov0[1] <- a0
  
  f <- expression(
      (s11 + y11) * log(p * ((p * ka11 + (1 - p) * ka10 * ka11) / ((1 - p) * ka10 + p * ka11)) * ((p * ka21 + (1 - p) * ka20 * ka21) / ((1 - p) * ka20 + p * ka21)) * a1) +  
              
      (s10 + y10) * log(p * (((p * ka11 + (1 - p) * ka10 * ka11) / ((1 - p) * ka10 + p * ka11)) * (1 - ((p * ka21 + (1 - p) * ka20 * ka21) / ((1 - p) * ka20 + p * ka21))) - (a1 - 1) * ((p * ka11 + (1 - p) * ka10 * ka11) / ((1 - p) * ka10 + p * ka11)) * ((p * ka21 + (1 - p) * ka20 * ka21) / ((1 - p) * ka20 + p * ka21)))) +
             
      (s01 + y01) * log(p * (((p * ka21 + (1 - p) * ka20 * ka21) / ((1 - p) * ka20 + p * ka21)) * (1 - ((p * ka11 + (1 - p) * ka10 * ka11) / ((1 - p) * ka10 + p * ka11))) - (a1 - 1) * ((p * ka11 + (1 - p) * ka10 * ka11) / ((1 - p) * ka10 + p * ka11)) * ((p * ka21 + (1 - p) * ka20 * ka21) / ((1 - p) * ka20 + p * ka21)))) +
              
      (s00 + y00) * log(p * ((1 - ((p * ka11 + (1 - p) * ka10 * ka11) / ((1 - p) * ka10 + p * ka11))) * (1 - ((p * ka21 + (1 - p) * ka20 * ka21) / ((1 - p) * ka20 + p * ka21))) + (a1 - 1) * ((p * ka11 + (1 - p) * ka10 * ka11) / ((1 - p) * ka10 + p * ka11)) * ((p * ka21 + (1 - p) * ka20 * ka21) / ((1 - p) * ka20 + p * ka21)))) + 
               
      (r11 + u11 - y11) * log((1 - p) * (a0 * (1 - (((1 - p) * ka10 + p * ka10 * ka11) / ((1 - p) * ka10 + p * ka11))) * (1 - (((1 - p) * ka20 + p * ka20 * ka21) / ((1 - p) * ka20 + p * ka21))))) + 
               
      (r10 + u10 - y10) * log((1 - p) * ((1 - (((1 - p) * ka10 + p * ka10 * ka11) / ((1 - p) * ka10 + p * ka11))) * (((1 - p) * ka20 + p * ka20 * ka21) / ((1 - p) * ka20 + p * ka21)) - (a0 - 1) * (1 - (((1 - p) * ka10 + p * ka10 * ka11) / ((1 - p) * ka10 + p * ka11))) * (1 - (((1 - p) * ka20 + p * ka20 * ka21) / ((1 - p) * ka20 + p * ka21))))) + 
               
      (r01 + u01 - y01) * log((1 - p) * ((1 - (((1 - p) * ka20 + p * ka20 * ka21) / ((1 - p) * ka20 + p * ka21))) * (((1 - p) * ka10 + p * ka10 * ka11) / ((1 - p) * ka10 + p * ka11)) - (a0 - 1) * (1 - (((1 - p) * ka10 + p * ka10 * ka11) / ((1 - p) * ka10 + p * ka11))) * (1 - (((1 - p) * ka20 + p * ka20 * ka21) / ((1 - p) * ka20 + p * ka21))))) + 
               
      (r00 + u00 - y00) * log((1 - p) * ((((1 - p) * ka10 + p * ka10 * ka11) / ((1 - p) * ka10 + p * ka11)) * (((1 - p) * ka20 + p * ka20 * ka21) / ((1 - p) * ka20 + p * ka21)) + (a0 - 1) * (1 - (((1 - p) * ka10 + p * ka10 * ka11) / ((1 - p) * ka10 + p * ka11))) * (1 - (((1 - p) * ka20 + p * ka20 * ka21) / ((1 - p) * ka20 + p * ka21)))))       
    )

  
  i <- 1
  
  maxit <- 10^10
  
  while (i < maxit)
  {
    i <- i + 1
    
    if (is.nan(eval(f))) cat("There are many frequencies equal to zero. The method cannot be applied", "\n")
    
    if (is.nan(eval(f))) break
     
    f1 <- eval(f)
              
    f11 <- (a1 * p * (ka10 * ka11 *(1 - p) + ka11 * p) * (ka20 * ka21 * (1 - p) + ka21  * p)) / ((ka10 * (1 - p) + ka11 * p) * (ka20 * (1 - p) + ka21 * p)) 
       
    f10 <- (ka11 * p * (ka10 + p - ka10 * p) * (1 + (a1 *  ka21 * (ka20 + p - ka20 * p)) / (ka20 * (-1 + p) - ka21 * p))) / (ka10 - ka10 * p + ka11 * p) 
       
    f01 <- (ka21 * p * (ka20 + p - ka20 * p) * (1 + (a1 * ka11 * (ka10 + p - ka10 * p))/(ka10 * (-1 + p) - ka11 * p)))/(ka20 - ka20 * p + ka21 * p)
          
    f00 <- (p  * (-(-1 + a1) * ka11 * ka21 * (ka20 * (-1 + p) - p) * p + ka10 * (-1 + p) * (ka20 * (1 - ka11 - ka21 + a1 * ka11 * ka21) * (-1 + p) - (-1 + a1)* ka11 * ka21 * p))) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))  
    
    g11 <- -((a0 * (-1 + ka10) * ka11 *(-1 + ka20) * ka21 * (-1 + p) * p * p) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))) 
      
    g10 <- ((-1 + ka10) * ka11 * (-1 + p) * p * (ka20 + (ka21 - a0 * ka21 + ka20 * (-1 + a0 * ka21)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
       
    g01 <- ((-1 + ka20) * ka21 * (-1 + p) * p * (ka10 + (ka11 - a0 * ka11 + ka10 *(-1 + a0 * ka11)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
        
    g00 <- -((-1 + p) *  (ka10 * ka20 + ka10 * ka20 * (-2 + ka11 + ka21) * p + (-ka10 * (-1 + ka11) * ka20 + (-ka10 * ka20 + ka11 * (-1 + ka10 + a0 * (-1 + ka10) * (-1 + ka20) + ka20)) * ka21) * p * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
    
    y11 <- u11 * f11 / (f11 + g11)
    y10 <- u10 * f10 / (f10 + g10)
    y01 <- u01 * f01 / (f01 + g01)
    y00 <- u00 * f00 / (f00 + g00)
    y <- y11 + y10 + y01 + y00
    
    ka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
    ka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
    
    ka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
    ka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
  
    p <- (ss + y) / n
    
    a1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
    a0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
    
    kappa10[i] <- ka10
    kappa11[i] <- ka11
    
    kappa20[i] <- ka20
    kappa21[i] <- ka21
    
    prev[i] <- p
    
    cov1[i] <- a1
    cov0[i] <- a0
        
    if (is.nan(eval(f))) cat("There are many frequencies equal to zero. The method cannot be applied", "\n")
    
    if (is.nan(eval(f))) break
    
    f2 <- eval(f)
    
    if (abs(f1 - f2) <= delta) break 
  }
  
  ka10 <- kappa10[length(kappa10)]
  ka11 <- kappa11[length(kappa11)]
  
  ka20 <- kappa20[length(kappa20)]
  ka21 <- kappa21[length(kappa21)]
  
  p <- prev[length(prev)]
  
  a1 <- cov1[length(cov1)]
  a0 <- cov0[length(cov0)]
  
       
  Se1 <- ((p * ka11 + (1 - p) * ka10 * ka11) / ((1 - p) * ka10 + p * ka11))  # Sensitivity of Test 1
  Se2 <- ((p * ka21 + (1 - p) * ka20 * ka21) / ((1 - p) * ka20 + p * ka21))  # Sensitivity of Test 2
  
  Sp1 <- (((1 - p) * ka10 + p * ka10 * ka11) / ((1 - p) * ka10 + p * ka11))  # Specificity of Test 1
  Sp2 <- (((1 - p) * ka20 + p * ka20 * ka21) / ((1 - p) * ka20 + p * ka21))  # Specificity of Test 2
  
  You1 <- Se1 + Sp1 - 1  # Youden index of Test 1
  You2 <- Se2 + Sp2 - 1  # Youden index of Test 2

  if (You1 <= 0 | You2 <= 0)
    {
      cat("\n")
      cat("Estimated Youden index of Test 1 is ", You1, "\n")
      cat("\n")
      cat("Estimated Youden index of Test 2 is ", You2, "\n")
      cat("\n")
      stop("Estimated Youden index of a diagnostic test must be greater than zero. Introduces new values \n")
      cat("\n")
    }
    
  Q1 <- p * Se1 + (1 - p) * (1 - Sp1)
  
  Q2 <- p * Se2 + (1 - p) * (1 - Sp2)
  
  if(p - Q1 == 0) averageka11 <- You1 else averageka11 <- (2 * ka10 * ka11 / (ka10 - ka11)) * log((ka10 + ka11) / (2 * ka11))
  if(p - Q2 == 0) averageka21 <- You2 else averageka21 <- (2 * ka20 * ka21 / (ka20 - ka21)) * log((ka20 + ka21) / (2 * ka21))
  
  if(p - Q1 == 0) averageka12 <- You1 else averageka12 <- (2 * ka10 * ka11 / (ka10 - ka11)) * log((2 * ka10) / (ka10 + ka11))
  if(p - Q1 == 0) averageka22 <- You2 else averageka22 <- (2 * ka20 * ka21 / (ka20 - ka21)) * log((2 * ka20) / (ka20 + ka21)) 
  
  
  # Complete data log likelihood function
         
  # Derivatives
  
  deri11 <- D(D(f,"ka10"),"ka10")
  deri12 <- D(D(f,"ka10"),"ka11")
  deri13 <- D(D(f,"ka10"),"ka20")
  deri14 <- D(D(f,"ka10"),"ka21")
  deri15 <- D(D(f,"ka10"),"p")
  deri16 <- D(D(f,"ka10"),"a1")
  deri17 <- D(D(f,"ka10"),"a0")
  
  deri21 <- D(D(f,"ka11"),"ka10")
  deri22 <- D(D(f,"ka11"),"ka11")
  deri23 <- D(D(f,"ka11"),"ka20")
  deri24 <- D(D(f,"ka11"),"ka21")
  deri25 <- D(D(f,"ka11"),"p")
  deri26 <- D(D(f,"ka11"),"a1")
  deri27 <- D(D(f,"ka11"),"a0")
  
  deri31 <- D(D(f,"ka20"),"ka10")
  deri32 <- D(D(f,"ka20"),"ka11")
  deri33 <- D(D(f,"ka20"),"ka20")
  deri34 <- D(D(f,"ka20"),"ka21")
  deri35 <- D(D(f,"ka20"),"p")
  deri36 <- D(D(f,"ka20"),"a1")
  deri37 <- D(D(f,"ka20"),"a0")
            
  deri41 <- D(D(f,"ka21"),"ka10")
  deri42 <- D(D(f,"ka21"),"ka11")
  deri43 <- D(D(f,"ka21"),"ka20")
  deri44 <- D(D(f,"ka21"),"ka21")
  deri45 <- D(D(f,"ka21"),"p")
  deri46 <- D(D(f,"ka21"),"a1")
  deri47 <- D(D(f,"ka21"),"a0")
  
  deri51 <- D(D(f,"p"),"ka10")
  deri52 <- D(D(f,"p"),"ka11")
  deri53 <- D(D(f,"p"),"ka20")
  deri54 <- D(D(f,"p"),"ka21")
  deri55 <- D(D(f,"p"),"p")
  deri56 <- D(D(f,"p"),"a1")
  deri57 <- D(D(f,"p"),"a0")
  
  deri61 <- D(D(f,"a1"),"ka10")
  deri62 <- D(D(f,"a1"),"ka11")
  deri63 <- D(D(f,"a1"),"ka20")
  deri64 <- D(D(f,"a1"),"ka21")
  deri65 <- D(D(f,"a1"),"p")
  deri66 <- D(D(f,"a1"),"a1")
  deri67 <- D(D(f,"a1"),"a0")
   
  deri71 <- D(D(f,"a0"),"ka10")
  deri72 <- D(D(f,"a0"),"ka11")
  deri73 <- D(D(f,"a0"),"ka20")
  deri74 <- D(D(f,"a0"),"ka21")
  deri75 <- D(D(f,"a0"),"p")
  deri76 <- D(D(f,"a0"),"a1")
  deri77 <- D(D(f,"a0"),"a0")
  
  # Fisher information matrix of the complete data
  
  fis <- matrix(0, 7, 7, dimnames = list(c("Kappa10", "Kappa11", "Kappa20", "Kappa21", "p", "a1", "a0"), c("Kappa10", "Kappa11", "Kappa20", "Kappa21", "p", "a1", "a0")))
  
  fis[1,1] <- - eval(deri11)
  fis[1,2] <- - eval(deri12)
  fis[1,3] <- - eval(deri13)
  fis[1,4] <- - eval(deri14)
  fis[1,5] <- - eval(deri15)
  fis[1,6] <- - eval(deri16)
  fis[1,7] <- - eval(deri17)
  
  fis[2,1] <- - eval(deri21)
  fis[2,2] <- - eval(deri22)
  fis[2,3] <- - eval(deri23)
  fis[2,4] <- - eval(deri24)
  fis[2,5] <- - eval(deri25)
  fis[2,6] <- - eval(deri26)
  fis[2,7] <- - eval(deri27)
  
  fis[3,1] <- - eval(deri31)
  fis[3,2] <- - eval(deri32)
  fis[3,3] <- - eval(deri33)
  fis[3,4] <- - eval(deri34)
  fis[3,5] <- - eval(deri35)
  fis[3,6] <- - eval(deri36)
  fis[3,7] <- - eval(deri37)
  
  fis[4,1] <- - eval(deri41)
  fis[4,2] <- - eval(deri42)
  fis[4,3] <- - eval(deri43)
  fis[4,4] <- - eval(deri44)
  fis[4,5] <- - eval(deri45)
  fis[4,6] <- - eval(deri46)
  fis[4,7] <- - eval(deri47)
  
  fis[5,1] <- - eval(deri51)
  fis[5,2] <- - eval(deri52)
  fis[5,3] <- - eval(deri53)
  fis[5,4] <- - eval(deri54)
  fis[5,5] <- - eval(deri55)
  fis[5,6] <- - eval(deri56)
  fis[5,7] <- - eval(deri57)
  
  fis[6,1] <- - eval(deri61)
  fis[6,2] <- - eval(deri62)
  fis[6,3] <- - eval(deri63)
  fis[6,4] <- - eval(deri64)
  fis[6,5] <- - eval(deri65)
  fis[6,6] <- - eval(deri66)
  fis[6,7] <- - eval(deri67)
  
  fis[7,1] <- - eval(deri71)
  fis[7,2] <- - eval(deri72)
  fis[7,3] <- - eval(deri73)
  fis[7,4] <- - eval(deri74)
  fis[7,5] <- - eval(deri75)
  fis[7,6] <- - eval(deri76)
  fis[7,7] <- - eval(deri77)
    
  if (is.nan(det(fis))) cat("The method cannot be applied", "\n")
  
  if (is.nan(det(fis))) break
  
  invfis <- solve(fis)   # Inverse matrix of Fisher
  
  
  # DM Matrix: r1j
  
  x <- kappa10[1]
  
  f11 <- (a1 * p * (x * ka11 *(1 - p) + ka11 * p) * (ka20 * ka21 * (1 - p) + ka21  * p)) / ((x * (1 - p) + ka11 * p) * (ka20 * (1 - p) + ka21 * p))

  f10 <- (ka11 * p * (x + p - x * p) * (1 + (a1 *  ka21 * (ka20 + p - ka20 * p)) / (ka20 * (-1 + p) - ka21 * p))) / (x - x * p + ka11 * p)

  f01 <- (ka21 * p * (ka20 + p - ka20 * p) * (1 + (a1 * ka11 * (x + p - x * p))/(x * (-1 + p) - ka11 * p)))/(ka20 - ka20 * p + ka21 * p)

  f00 <- (p  * (-(-1 + a1) * ka11 * ka21 * (ka20 * (-1 + p) - p) * p + x * (-1 + p) * (ka20 * (1 - ka11 - ka21 + a1 * ka11 * ka21) * (-1 + p) - (-1 + a1)* ka11 * ka21 * p))) / ((x * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

  g11 <- -((a0 * (-1 + x) * ka11 *(-1 + ka20) * ka21 * (-1 + p) * p * p) / ((x * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p)))

  g10 <- ((-1 + x) * ka11 * (-1 + p) * p * (ka20 + (ka21 - a0 * ka21 + ka20 * (-1 + a0 * ka21)) * p)) / ((x * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

  g01 <- ((-1 + ka20) * ka21 * (-1 + p) * p * (x + (ka11 - a0 * ka11 + x *(-1 + a0 * ka11)) * p)) / ((x * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

  g00 <- -((-1 + p) *  (x * ka20 + x * ka20 * (-2 + ka11 + ka21) * p + (-x * (-1 + ka11) * ka20 + (-x * ka20 + ka11 * (-1 + x + a0 * (-1 + x) * (-1 + ka20) + ka20)) * ka21) * p * p)) / ((x * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

  y11 <- u11 * f11 / (f11 + g11)
  y10 <- u10 * f10 / (f10 + g10)
  y01 <- u01 * f01 / (f01 + g01)
  y00 <- u00 * f00 / (f00 + g00)
  y <- y11 + y10 + y01 + y00
    
  emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
  emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
    
  emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
  emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
    
  emp <- (ss + y) / n  
  
  ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
  ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
    
  vec1 <- vector()
  vec2 <- vector()
  vec3 <- vector()
  vec4 <- vector()
  vec5 <- vector()
  vec6 <- vector()
  vec7 <- vector()  
  
  vec1[1] <- (emka10 - ka10) / (x - ka10)
  vec2[1] <- (emka11 - ka11) / (x - ka10)
  vec3[1] <- (emka20 - ka20) / (x - ka10)
  vec4[1] <- (emka21 - ka21) / (x - ka10)
  vec5[1] <- (emp - p) / (x - ka10)
  vec6[1] <- (ema1 - a1) / (x - ka10)
  vec7[1] <- (ema0 - a0) / (x - ka10)            
            
  j <- 1
    
  while (j <= length(kappa10))
    {
      j <- j + 1
      
      x <- kappa10[j]
  
      f11 <- (a1 * p * (x * ka11 *(1 - p) + ka11 * p) * (ka20 * ka21 * (1 - p) + ka21  * p)) / ((x * (1 - p) + ka11 * p) * (ka20 * (1 - p) + ka21 * p))

      f10 <- (ka11 * p * (x + p - x * p) * (1 + (a1 *  ka21 * (ka20 + p - ka20 * p)) / (ka20 * (-1 + p) - ka21 * p))) / (x - x * p + ka11 * p)
    
      f01 <- (ka21 * p * (ka20 + p - ka20 * p) * (1 + (a1 * ka11 * (x + p - x * p))/(x * (-1 + p) - ka11 * p)))/(ka20 - ka20 * p + ka21 * p)
    
      f00 <- (p  * (-(-1 + a1) * ka11 * ka21 * (ka20 * (-1 + p) - p) * p + x * (-1 + p) * (ka20 * (1 - ka11 - ka21 + a1 * ka11 * ka21) * (-1 + p) - (-1 + a1)* ka11 * ka21 * p))) / ((x * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
    
      g11 <- -((a0 * (-1 + x) * ka11 *(-1 + ka20) * ka21 * (-1 + p) * p * p) / ((x * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p)))
    
      g10 <- ((-1 + x) * ka11 * (-1 + p) * p * (ka20 + (ka21 - a0 * ka21 + ka20 * (-1 + a0 * ka21)) * p)) / ((x * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
    
      g01 <- ((-1 + ka20) * ka21 * (-1 + p) * p * (x + (ka11 - a0 * ka11 + x *(-1 + a0 * ka11)) * p)) / ((x * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
    
      g00 <- -((-1 + p) *  (x * ka20 + x * ka20 * (-2 + ka11 + ka21) * p + (-x * (-1 + ka11) * ka20 + (-x * ka20 + ka11 * (-1 + x + a0 * (-1 + x) * (-1 + ka20) + ka20)) * ka21) * p * p)) / ((x * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

      y11 <- u11 * f11 / (f11 + g11)
      y10 <- u10 * f10 / (f10 + g10)
      y01 <- u01 * f01 / (f01 + g01)
      y00 <- u00 * f00 / (f00 + g00)
      y <- y11 + y10 + y01 + y00
        
      emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
      emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
        
      emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
      emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
        
      emp <- (ss + y) / n  
      
      ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
      ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
        
      if (x - ka10 == 0) break
    
      vec1[j] <- (emka10 - ka10) / (x - ka10)
      vec2[j] <- (emka11 - ka11) / (x - ka10)
      vec3[j] <- (emka20 - ka20) / (x - ka10)
      vec4[j] <- (emka21 - ka21) / (x - ka10)
      vec5[j] <- (emp - p) / (x - ka10)
      vec6[j] <- (ema1 - a1) / (x - ka10)
      vec7[j] <- (ema0 - a0) / (x - ka10)                    
    } 
  
  for(j in 2:length(vec1)) 
    {  
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) 
      {
        b11 <- vec1[j]
      }
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec2)) 
    {  
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) 
      {
        b12 <- vec2[j]
      }
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec3)) 
    {  
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) 
      {
        b13 <- vec3[j]
      }
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec4)) 
    {  
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) 
      {
        b14 <- vec4[j]
      }
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec5)) 
    {  
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) 
      {
        b15 <- vec5[j]
      }
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec6)) 
    {  
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) 
      {
        b16 <- vec6[j]
      }
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec7)) 
    {  
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) 
      {
        b17 <- vec7[j]
      }
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) break 
    } 
  
  
  # Matrix DM: r2j
  
  x <- kappa11[1]
  
  f11 <- (a1 * p * (ka10 * x *(1 - p) + x * p) * (ka20 * ka21 * (1 - p) + ka21  * p)) / ((ka10 * (1 - p) + x * p) * (ka20 * (1 - p) + ka21 * p))

  f10 <- (x * p * (ka10 + p - ka10 * p) * (1 + (a1 *  ka21 * (ka20 + p - ka20 * p)) / (ka20 * (-1 + p) - ka21 * p))) / (ka10 - ka10 * p + x * p)

  f01 <- (ka21 * p * (ka20 + p - ka20 * p) * (1 + (a1 * x * (ka10 + p - ka10 * p))/(ka10 * (-1 + p) - x * p)))/(ka20 - ka20 * p + ka21 * p)

  f00 <- (p  * (-(-1 + a1) * x * ka21 * (ka20 * (-1 + p) - p) * p + ka10 * (-1 + p) * (ka20 * (1 - x - ka21 + a1 * x * ka21) * (-1 + p) - (-1 + a1)* x * ka21 * p))) / ((ka10 * (-1 + p) - x * p) * (ka20 * (-1 + p) - ka21 * p))

  g11 <- -((a0 * (-1 + ka10) * x *(-1 + ka20) * ka21 * (-1 + p) * p * p) / ((ka10 * (-1 + p) - x * p) * (ka20 * (-1 + p) - ka21 * p)))

  g10 <- ((-1 + ka10) * x * (-1 + p) * p * (ka20 + (ka21 - a0 * ka21 + ka20 * (-1 + a0 * ka21)) * p)) / ((ka10 * (-1 + p) - x * p) * (ka20 * (-1 + p) - ka21 * p))

  g01 <- ((-1 + ka20) * ka21 * (-1 + p) * p * (ka10 + (x - a0 * x + ka10 *(-1 + a0 * x)) * p)) / ((ka10 * (-1 + p) - x * p) * (ka20 * (-1 + p) - ka21 * p))

  g00 <- -((-1 + p) *  (ka10 * ka20 + ka10 * ka20 * (-2 + x + ka21) * p + (-ka10 * (-1 + x) * ka20 + (-ka10 * ka20 + x * (-1 + ka10 + a0 * (-1 + ka10) * (-1 + ka20) + ka20)) * ka21) * p * p)) / ((ka10 * (-1 + p) - x * p) * (ka20 * (-1 + p) - ka21 * p))

  y11 <- u11 * f11 / (f11 + g11)
  y10 <- u10 * f10 / (f10 + g10)
  y01 <- u01 * f01 / (f01 + g01)
  y00 <- u00 * f00 / (f00 + g00)
  y <- y11 + y10 + y01 + y00
    
  emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
  emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
    
  emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
  emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
  
  emp <- (ss + y) / n
    
  ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
  ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
  
  vec1 <- vector()
  vec2 <- vector()
  vec3 <- vector()
  vec4 <- vector()
  vec5 <- vector()
  vec6 <- vector()
  vec7 <- vector()  
  
  vec1[1] <- (emka10 - ka10) / (x - ka11)
  vec2[1] <- (emka11 - ka11) / (x - ka11)
  vec3[1] <- (emka20 - ka20) / (x - ka11)
  vec4[1] <- (emka21 - ka21) / (x - ka11)
  vec5[1] <- (emp - p) / (x - ka11)
  vec6[1] <- (ema1 - a1) / (x - ka11)
  vec7[1] <- (ema0 - a0) / (x - ka11)            
            
  j <- 1
    
  while (j <= length(kappa11))
    {
      j <- j + 1
      
      x <- kappa11[j]
  
      f11 <- (a1 * p * (ka10 * x *(1 - p) + x * p) * (ka20 * ka21 * (1 - p) + ka21  * p)) / ((ka10 * (1 - p) + x * p) * (ka20 * (1 - p) + ka21 * p))

      f10 <- (x * p * (ka10 + p - ka10 * p) * (1 + (a1 *  ka21 * (ka20 + p - ka20 * p)) / (ka20 * (-1 + p) - ka21 * p))) / (ka10 - ka10 * p + x * p)
  
      f01 <- (ka21 * p * (ka20 + p - ka20 * p) * (1 + (a1 * x * (ka10 + p - ka10 * p))/(ka10 * (-1 + p) - x * p)))/(ka20 - ka20 * p + ka21 * p)
  
      f00 <- (p  * (-(-1 + a1) * x * ka21 * (ka20 * (-1 + p) - p) * p + ka10 * (-1 + p) * (ka20 * (1 - x - ka21 + a1 * x * ka21) * (-1 + p) - (-1 + a1)* x * ka21 * p))) / ((ka10 * (-1 + p) - x * p) * (ka20 * (-1 + p) - ka21 * p))
  
      g11 <- -((a0 * (-1 + ka10) * x *(-1 + ka20) * ka21 * (-1 + p) * p * p) / ((ka10 * (-1 + p) - x * p) * (ka20 * (-1 + p) - ka21 * p)))
  
      g10 <- ((-1 + ka10) * x * (-1 + p) * p * (ka20 + (ka21 - a0 * ka21 + ka20 * (-1 + a0 * ka21)) * p)) / ((ka10 * (-1 + p) - x * p) * (ka20 * (-1 + p) - ka21 * p))
  
      g01 <- ((-1 + ka20) * ka21 * (-1 + p) * p * (ka10 + (x - a0 * x + ka10 *(-1 + a0 * x)) * p)) / ((ka10 * (-1 + p) - x * p) * (ka20 * (-1 + p) - ka21 * p))
  
      g00 <- -((-1 + p) *  (ka10 * ka20 + ka10 * ka20 * (-2 + x + ka21) * p + (-ka10 * (-1 + x) * ka20 + (-ka10 * ka20 + x * (-1 + ka10 + a0 * (-1 + ka10) * (-1 + ka20) + ka20)) * ka21) * p * p)) / ((ka10 * (-1 + p) - x * p) * (ka20 * (-1 + p) - ka21 * p))

      y11 <- u11 * f11 / (f11 + g11)
      y10 <- u10 * f10 / (f10 + g10)
      y01 <- u01 * f01 / (f01 + g01)
      y00 <- u00 * f00 / (f00 + g00)
      y <- y11 + y10 + y01 + y00
        
      emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
      emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
        
      emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
      emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
      
      emp <- (ss + y) / n
        
      ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
      ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
  
      if (x - ka11 == 0) break
    
      vec1[j] <- (emka10 - ka10) / (x - ka11)
      vec2[j] <- (emka11 - ka11) / (x - ka11)
      vec3[j] <- (emka20 - ka20) / (x - ka11)
      vec4[j] <- (emka21 - ka21) / (x - ka11)
      vec5[j] <- (emp - p) / (x - ka11)
      vec6[j] <- (ema1 - a1) / (x - ka11)
      vec7[j] <- (ema0 - a0) / (x - ka11)                     
    } 
  
  for(j in 2:length(vec1)) 
    {  
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) 
      {
        b21 <- vec1[j]
      }
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec2)) 
    {  
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) 
      {
        b22 <- vec2[j]
      }
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec3)) 
    {  
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) 
      {
        b23 <- vec3[j]
      }
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec4)) 
    {  
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) 
      {
        b24 <- vec4[j]
      }
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec5)) 
    {  
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) 
      {
        b25 <- vec5[j]
      }
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec6)) 
    {  
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) 
      {
        b26 <- vec6[j]
      }
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec7)) 
    {  
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) 
      {
        b27 <- vec7[j]
      }
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) break 
    }

 
  # Matrix DM: r3j
  
  x <- kappa20[1]
  
  f11 <- (a1 * p * (ka10 * ka11 *(1 - p) + ka11 * p) * (x * ka21 * (1 - p) + ka21  * p)) / ((ka10 * (1 - p) + ka11 * p) * (x * (1 - p) + ka21 * p))

  f10 <- (ka11 * p * (ka10 + p - ka10 * p) * (1 + (a1 *  ka21 * (x + p - x * p)) / (x * (-1 + p) - ka21 * p))) / (ka10 - ka10 * p + ka11 * p)

  f01 <- (ka21 * p * (x + p - x * p) * (1 + (a1 * ka11 * (ka10 + p - ka10 * p))/(ka10 * (-1 + p) - ka11 * p)))/(x - x * p + ka21 * p)

  f00 <- (p  * (-(-1 + a1) * ka11 * ka21 * (x * (-1 + p) - p) * p + ka10 * (-1 + p) * (x * (1 - ka11 - ka21 + a1 * ka11 * ka21) * (-1 + p) - (-1 + a1)* ka11 * ka21 * p))) / ((ka10 * (-1 + p) - ka11 * p) * (x * (-1 + p) - ka21 * p))

  g11 <- -((a0 * (-1 + ka10) * ka11 *(-1 + x) * ka21 * (-1 + p) * p * p) / ((ka10 * (-1 + p) - ka11 * p) * (x * (-1 + p) - ka21 * p)))

  g10 <- ((-1 + ka10) * ka11 * (-1 + p) * p * (x + (ka21 - a0 * ka21 + x * (-1 + a0 * ka21)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (x * (-1 + p) - ka21 * p))

  g01 <- ((-1 + x) * ka21 * (-1 + p) * p * (ka10 + (ka11 - a0 * ka11 + ka10 *(-1 + a0 * ka11)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (x * (-1 + p) - ka21 * p))

  g00 <- -((-1 + p) *  (ka10 * x + ka10 * x * (-2 + ka11 + ka21) * p + (-ka10 * (-1 + ka11) * x + (-ka10 * x + ka11 * (-1 + ka10 + a0 * (-1 + ka10) * (-1 + x) + x)) * ka21) * p * p)) / ((ka10 * (-1 + p) - ka11 * p) * (x * (-1 + p) - ka21 * p))

  y11 <- u11 * f11 / (f11 + g11)
  y10 <- u10 * f10 / (f10 + g10)
  y01 <- u01 * f01 / (f01 + g01)
  y00 <- u00 * f00 / (f00 + g00)
  y <- y11 + y10 + y01 + y00
    
  emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
  emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
    
  emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
  emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
  
  emp <- (ss + y) / n
    
  ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
  ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
  
  vec1 <- vector()
  vec2 <- vector()
  vec3 <- vector()
  vec4 <- vector()
  vec5 <- vector()
  vec6 <- vector()
  vec7 <- vector()  
  
  vec1[1] <- (emka10 - ka10) / (x - ka20)
  vec2[1] <- (emka11 - ka11) / (x - ka20)
  vec3[1] <- (emka20 - ka20) / (x - ka20)
  vec4[1] <- (emka21 - ka21) / (x - ka20)
  vec5[1] <- (emp - p) / (x - ka20)
  vec6[1] <- (ema1 - a1) / (x - ka20)
  vec7[1] <- (ema0 - a0) / (x - ka20)            
            
  j <- 1
    
  while (j <= length(kappa20))
    {
      j <- j + 1
      
      x <- kappa20[j]
  
      f11 <- (a1 * p * (ka10 * ka11 *(1 - p) + ka11 * p) * (x * ka21 * (1 - p) + ka21  * p)) / ((ka10 * (1 - p) + ka11 * p) * (x * (1 - p) + ka21 * p))

      f10 <- (ka11 * p * (ka10 + p - ka10 * p) * (1 + (a1 *  ka21 * (x + p - x * p)) / (x * (-1 + p) - ka21 * p))) / (ka10 - ka10 * p + ka11 * p)
  
      f01 <- (ka21 * p * (x + p - x * p) * (1 + (a1 * ka11 * (ka10 + p - ka10 * p))/(ka10 * (-1 + p) - ka11 * p)))/(x - x * p + ka21 * p)
  
      f00 <- (p  * (-(-1 + a1) * ka11 * ka21 * (x * (-1 + p) - p) * p + ka10 * (-1 + p) * (x * (1 - ka11 - ka21 + a1 * ka11 * ka21) * (-1 + p) - (-1 + a1)* ka11 * ka21 * p))) / ((ka10 * (-1 + p) - ka11 * p) * (x * (-1 + p) - ka21 * p))
  
      g11 <- -((a0 * (-1 + ka10) * ka11 *(-1 + x) * ka21 * (-1 + p) * p * p) / ((ka10 * (-1 + p) - ka11 * p) * (x * (-1 + p) - ka21 * p)))
  
      g10 <- ((-1 + ka10) * ka11 * (-1 + p) * p * (x + (ka21 - a0 * ka21 + x * (-1 + a0 * ka21)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (x * (-1 + p) - ka21 * p))
  
      g01 <- ((-1 + x) * ka21 * (-1 + p) * p * (ka10 + (ka11 - a0 * ka11 + ka10 *(-1 + a0 * ka11)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (x * (-1 + p) - ka21 * p))
  
      g00 <- -((-1 + p) *  (ka10 * x + ka10 * x * (-2 + ka11 + ka21) * p + (-ka10 * (-1 + ka11) * x + (-ka10 * x + ka11 * (-1 + ka10 + a0 * (-1 + ka10) * (-1 + x) + x)) * ka21) * p * p)) / ((ka10 * (-1 + p) - ka11 * p) * (x * (-1 + p) - ka21 * p))

      y11 <- u11 * f11 / (f11 + g11)
      y10 <- u10 * f10 / (f10 + g10)
      y01 <- u01 * f01 / (f01 + g01)
      y00 <- u00 * f00 / (f00 + g00)
      y <- y11 + y10 + y01 + y00
        
      emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
      emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
        
      emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
      emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
      
      emp <- (ss + y) / n
        
      ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
      ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
  
      if (x - ka20 == 0) break
    
      vec1[j] <- (emka10 - ka10) / (x - ka20)
      vec2[j] <- (emka11 - ka11) / (x - ka20)
      vec3[j] <- (emka20 - ka20) / (x - ka20)
      vec4[j] <- (emka21 - ka21) / (x - ka20)
      vec5[j] <- (emp - p) / (x - ka20)
      vec6[j] <- (ema1 - a1) / (x - ka20)
      vec7[j] <- (ema0 - a0) / (x - ka20)                    
    } 
  
  for(j in 2:length(vec1)) 
    {  
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) 
      {
        b31 <- vec1[j]
      }
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec2)) 
    {  
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) 
      {
        b32 <- vec2[j]
      }
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec3)) 
    {  
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) 
      {
        b33 <- vec3[j]
      }
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec4)) 
    {  
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) 
      {
        b34 <- vec4[j]
      }
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec5)) 
    {  
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) 
      {
        b35 <- vec5[j]
      }
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec6)) 
    {  
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) 
      {
        b36 <- vec6[j]
      }
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec7)) 
    {  
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) 
      {
        b37 <- vec7[j]
      }
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) break 
    }
  

  # Matrix DM: r4j
  
  x <- kappa21[1]
  
  f11 <- (a1 * p * (ka10 * ka11 *(1 - p) + ka11 * p) * (ka20 * x * (1 - p) + x  * p)) / ((ka10 * (1 - p) + ka11 * p) * (ka20 * (1 - p) + x * p))

  f10 <- (ka11 * p * (ka10 + p - ka10 * p) * (1 + (a1 *  x * (ka20 + p - ka20 * p)) / (ka20 * (-1 + p) - x * p))) / (ka10 - ka10 * p + ka11 * p)

  f01 <- (x * p * (ka20 + p - ka20 * p) * (1 + (a1 * ka11 * (ka10 + p - ka10 * p))/(ka10 * (-1 + p) - ka11 * p)))/(ka20 - ka20 * p + x * p)

  f00 <- (p  * (-(-1 + a1) * ka11 * x * (ka20 * (-1 + p) - p) * p + ka10 * (-1 + p) * (ka20 * (1 - ka11 - x + a1 * ka11 * x) * (-1 + p) - (-1 + a1)* ka11 * x * p))) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - x * p))

  g11 <- -((a0 * (-1 + ka10) * ka11 *(-1 + ka20) * x * (-1 + p) * p * p) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - x * p)))

  g10 <- ((-1 + ka10) * ka11 * (-1 + p) * p * (ka20 + (x - a0 * x + ka20 * (-1 + a0 * x)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - x * p))

  g01 <- ((-1 + ka20) * x * (-1 + p) * p * (ka10 + (ka11 - a0 * ka11 + ka10 *(-1 + a0 * ka11)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - x * p))

  g00 <- -((-1 + p) *  (ka10 * ka20 + ka10 * ka20 * (-2 + ka11 + x) * p + (-ka10 * (-1 + ka11) * ka20 + (-ka10 * ka20 + ka11 * (-1 + ka10 + a0 * (-1 + ka10) * (-1 + ka20) + ka20)) * x) * p * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - x * p))

  y11 <- u11 * f11 / (f11 + g11)
  y10 <- u10 * f10 / (f10 + g10)
  y01 <- u01 * f01 / (f01 + g01)
  y00 <- u00 * f00 / (f00 + g00)
  y <- y11 + y10 + y01 + y00
    
  emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
  emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
    
  emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
  emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
  
  emp <- (ss + y) / n
    
  ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
  ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
  
  vec1 <- vector()
  vec2 <- vector()
  vec3 <- vector()
  vec4 <- vector()
  vec5 <- vector()
  vec6 <- vector()
  vec7 <- vector()  
  
  vec1[1] <- (emka10 - ka10) / (x - ka21)
  vec2[1] <- (emka11 - ka11) / (x - ka21)
  vec3[1] <- (emka20 - ka20) / (x - ka21)
  vec4[1] <- (emka21 - ka21) / (x - ka21)
  vec5[1] <- (emp - p) / (x - ka21)
  vec6[1] <- (ema1 - a1) / (x - ka21)
  vec7[1] <- (ema0 - a0) / (x - ka21)            
            
  j <- 1
    
  while (j <= length(kappa21))
    {
      j <- j + 1
      
      x <- kappa21[j]
  
      f11 <- (a1 * p * (ka10 * ka11 *(1 - p) + ka11 * p) * (ka20 * x * (1 - p) + x  * p)) / ((ka10 * (1 - p) + ka11 * p) * (ka20 * (1 - p) + x * p))

      f10 <- (ka11 * p * (ka10 + p - ka10 * p) * (1 + (a1 *  x * (ka20 + p - ka20 * p)) / (ka20 * (-1 + p) - x * p))) / (ka10 - ka10 * p + ka11 * p)
  
      f01 <- (x * p * (ka20 + p - ka20 * p) * (1 + (a1 * ka11 * (ka10 + p - ka10 * p))/(ka10 * (-1 + p) - ka11 * p)))/(ka20 - ka20 * p + x * p)
  
      f00 <- (p  * (-(-1 + a1) * ka11 * x * (ka20 * (-1 + p) - p) * p + ka10 * (-1 + p) * (ka20 * (1 - ka11 - x + a1 * ka11 * x) * (-1 + p) - (-1 + a1)* ka11 * x * p))) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - x * p))
  
      g11 <- -((a0 * (-1 + ka10) * ka11 *(-1 + ka20) * x * (-1 + p) * p * p) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - x * p)))
  
      g10 <- ((-1 + ka10) * ka11 * (-1 + p) * p * (ka20 + (x - a0 * x + ka20 * (-1 + a0 * x)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - x * p))
  
      g01 <- ((-1 + ka20) * x * (-1 + p) * p * (ka10 + (ka11 - a0 * ka11 + ka10 *(-1 + a0 * ka11)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - x * p))
  
      g00 <- -((-1 + p) *  (ka10 * ka20 + ka10 * ka20 * (-2 + ka11 + x) * p + (-ka10 * (-1 + ka11) * ka20 + (-ka10 * ka20 + ka11 * (-1 + ka10 + a0 * (-1 + ka10) * (-1 + ka20) + ka20)) * x) * p * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - x * p))

      y11 <- u11 * f11 / (f11 + g11)
      y10 <- u10 * f10 / (f10 + g10)
      y01 <- u01 * f01 / (f01 + g01)
      y00 <- u00 * f00 / (f00 + g00)
      y <- y11 + y10 + y01 + y00
        
      emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
      emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
        
      emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
      emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
      
      emp <- (ss + y) / n
        
      ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
      ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
  
      if (x - ka21 == 0) break
    
      vec1[j] <- (emka10 - ka10) / (x - ka21)
      vec2[j] <- (emka11 - ka11) / (x - ka21)
      vec3[j] <- (emka20 - ka20) / (x - ka21)
      vec4[j] <- (emka21 - ka21) / (x - ka21)
      vec5[j] <- (emp - p) / (x - ka21)
      vec6[j] <- (ema1 - a1) / (x - ka21)
      vec7[j] <- (ema0 - a0) / (x - ka21)                    
    } 
  
  for(j in 2:length(vec1)) 
    {  
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) 
      {
        b41 <- vec1[j]
      }
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec2)) 
    {  
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) 
      {
        b42 <- vec2[j]
      }
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec3)) 
    {  
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) 
      {
        b43 <- vec3[j]
      }
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec4)) 
    {  
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) 
      {
        b44 <- vec4[j]
      }
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec5)) 
    {  
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) 
      {
        b45 <- vec5[j]
      }
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec6)) 
    {  
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) 
      {
        b46 <- vec6[j]
      }
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec7)) 
    {  
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) 
      {
        b47 <- vec7[j]
      }
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) break 
    }

  
  # Matrix DM: r5j
  
  x <- prev[1]
  
  f11 <- (a1 * x * (ka10 * ka11 *(1 - x) + ka11 * x) * (ka20 * ka21 * (1 - x) + ka21  * x)) / ((ka10 * (1 - x) + ka11 * x) * (ka20 * (1 - x) + ka21 * x))

  f10 <- (ka11 * x * (ka10 + x - ka10 * x) * (1 + (a1 *  ka21 * (ka20 + x - ka20 * x)) / (ka20 * (-1 + x) - ka21 * x))) / (ka10 - ka10 * x + ka11 * x)

  f01 <- (ka21 * x * (ka20 + x - ka20 * x) * (1 + (a1 * ka11 * (ka10 + x - ka10 * x))/(ka10 * (-1 + x) - ka11 * x)))/(ka20 - ka20 * x + ka21 * x)

  f00 <- (x  * (-(-1 + a1) * ka11 * ka21 * (ka20 * (-1 + x) - x) * x + ka10 * (-1 + x) * (ka20 * (1 - ka11 - ka21 + a1 * ka11 * ka21) * (-1 + x) - (-1 + a1)* ka11 * ka21 * x))) / ((ka10 * (-1 + x) - ka11 * x) * (ka20 * (-1 + x) - ka21 * x))

  g11 <- -((a0 * (-1 + ka10) * ka11 *(-1 + ka20) * ka21 * (-1 + x) * x * x) / ((ka10 * (-1 + x) - ka11 * x) * (ka20 * (-1 + x) - ka21 * x)))

  g10 <- ((-1 + ka10) * ka11 * (-1 + x) * x * (ka20 + (ka21 - a0 * ka21 + ka20 * (-1 + a0 * ka21)) * x)) / ((ka10 * (-1 + x) - ka11 * x) * (ka20 * (-1 + x) - ka21 * x))

  g01 <- ((-1 + ka20) * ka21 * (-1 + x) * x * (ka10 + (ka11 - a0 * ka11 + ka10 *(-1 + a0 * ka11)) * x)) / ((ka10 * (-1 + x) - ka11 * x) * (ka20 * (-1 + x) - ka21 * x))

  g00 <- -((-1 + x) *  (ka10 * ka20 + ka10 * ka20 * (-2 + ka11 + ka21) * x + (-ka10 * (-1 + ka11) * ka20 + (-ka10 * ka20 + ka11 * (-1 + ka10 + a0 * (-1 + ka10) * (-1 + ka20) + ka20)) * ka21) * x * x)) / ((ka10 * (-1 + x) - ka11 * x) * (ka20 * (-1 + x) - ka21 * x))

  y11 <- u11 * f11 / (f11 + g11)
  y10 <- u10 * f10 / (f10 + g10)
  y01 <- u01 * f01 / (f01 + g01)
  y00 <- u00 * f00 / (f00 + g00)
  y <- y11 + y10 + y01 + y00
    
  emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
  emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
    
  emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
  emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
  
  emp <- (ss + y) / n
    
  ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
  ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
  
  vec1 <- vector()
  vec2 <- vector()
  vec3 <- vector()
  vec4 <- vector()
  vec5 <- vector()
  vec6 <- vector()
  vec7 <- vector()  
  
  vec1[1] <- (emka10 - ka10) / (x - p)
  vec2[1] <- (emka11 - ka11) / (x - p)
  vec3[1] <- (emka20 - ka20) / (x - p)
  vec4[1] <- (emka21 - ka21) / (x - p)
  vec5[1] <- (emp - p) / (x - p)
  vec6[1] <- (ema1 - a1) / (x - p)
  vec7[1] <- (ema0 - a0) / (x - p)             
            
  j <- 1
    
  while (j <= length(prev))
    {
      j <- j + 1
      
      x <- prev[j]
  
      f11 <- (a1 * x * (ka10 * ka11 *(1 - x) + ka11 * x) * (ka20 * ka21 * (1 - x) + ka21  * x)) / ((ka10 * (1 - x) + ka11 * x) * (ka20 * (1 - x) + ka21 * x))

      f10 <- (ka11 * x * (ka10 + x - ka10 * x) * (1 + (a1 *  ka21 * (ka20 + x - ka20 * x)) / (ka20 * (-1 + x) - ka21 * x))) / (ka10 - ka10 * x + ka11 * x)
  
      f01 <- (ka21 * x * (ka20 + x - ka20 * x) * (1 + (a1 * ka11 * (ka10 + x - ka10 * x))/(ka10 * (-1 + x) - ka11 * x)))/(ka20 - ka20 * x + ka21 * x)
  
      f00 <- (x  * (-(-1 + a1) * ka11 * ka21 * (ka20 * (-1 + x) - x) * x + ka10 * (-1 + x) * (ka20 * (1 - ka11 - ka21 + a1 * ka11 * ka21) * (-1 + x) - (-1 + a1)* ka11 * ka21 * x))) / ((ka10 * (-1 + x) - ka11 * x) * (ka20 * (-1 + x) - ka21 * x))
  
      g11 <- -((a0 * (-1 + ka10) * ka11 *(-1 + ka20) * ka21 * (-1 + x) * x * x) / ((ka10 * (-1 + x) - ka11 * x) * (ka20 * (-1 + x) - ka21 * x)))
  
      g10 <- ((-1 + ka10) * ka11 * (-1 + x) * x * (ka20 + (ka21 - a0 * ka21 + ka20 * (-1 + a0 * ka21)) * x)) / ((ka10 * (-1 + x) - ka11 * x) * (ka20 * (-1 + x) - ka21 * x))
  
      g01 <- ((-1 + ka20) * ka21 * (-1 + x) * x * (ka10 + (ka11 - a0 * ka11 + ka10 *(-1 + a0 * ka11)) * x)) / ((ka10 * (-1 + x) - ka11 * x) * (ka20 * (-1 + x) - ka21 * x))
  
      g00 <- -((-1 + x) *  (ka10 * ka20 + ka10 * ka20 * (-2 + ka11 + ka21) * x + (-ka10 * (-1 + ka11) * ka20 + (-ka10 * ka20 + ka11 * (-1 + ka10 + a0 * (-1 + ka10) * (-1 + ka20) + ka20)) * ka21) * x * x)) / ((ka10 * (-1 + x) - ka11 * x) * (ka20 * (-1 + x) - ka21 * x))

      y11 <- u11 * f11 / (f11 + g11)
      y10 <- u10 * f10 / (f10 + g10)
      y01 <- u01 * f01 / (f01 + g01)
      y00 <- u00 * f00 / (f00 + g00)
      y <- y11 + y10 + y01 + y00
        
      emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
      emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
        
      emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
      emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
      
      emp <- (ss + y) / n
        
      ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
      ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
  
      if (x - p == 0) break
    
      vec1[j] <- (emka10 - ka10) / (x - p)
      vec2[j] <- (emka11 - ka11) / (x - p)
      vec3[j] <- (emka20 - ka20) / (x - p)
      vec4[j] <- (emka21 - ka21) / (x - p)
      vec5[j] <- (emp - p) / (x - p)
      vec6[j] <- (ema1 - a1) / (x - p)
      vec7[j] <- (ema0 - a0) / (x - p)                   
    } 
  
  for(j in 2:length(vec1)) 
    {  
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) 
      {
        b51 <- vec1[j]
      }
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec2)) 
    {  
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) 
      {
        b52 <- vec2[j]
      }
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec3)) 
    {  
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) 
      {
        b53 <- vec3[j]
      }
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec4)) 
    {  
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) 
      {
        b54 <- vec4[j]
      }
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec5)) 
    {  
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) 
      {
        b55 <- vec5[j]
      }
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec6)) 
    {  
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) 
      {
        b56 <- vec6[j]
      }
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec7)) 
    {  
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) 
      {
        b57 <- vec7[j]
      }
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) break 
    }

  
  # Matrix DM: r6j
  
  x <- cov1[1]
  
  f11 <- (x * p * (ka10 * ka11 *(1 - p) + ka11 * p) * (ka20 * ka21 * (1 - p) + ka21  * p)) / ((ka10 * (1 - p) + ka11 * p) * (ka20 * (1 - p) + ka21 * p))

  f10 <- (ka11 * p * (ka10 + p - ka10 * p) * (1 + (x *  ka21 * (ka20 + p - ka20 * p)) / (ka20 * (-1 + p) - ka21 * p))) / (ka10 - ka10 * p + ka11 * p)

  f01 <- (ka21 * p * (ka20 + p - ka20 * p) * (1 + (x * ka11 * (ka10 + p - ka10 * p))/(ka10 * (-1 + p) - ka11 * p)))/(ka20 - ka20 * p + ka21 * p)

  f00 <- (p  * (-(-1 + x) * ka11 * ka21 * (ka20 * (-1 + p) - p) * p + ka10 * (-1 + p) * (ka20 * (1 - ka11 - ka21 + x * ka11 * ka21) * (-1 + p) - (-1 + x)* ka11 * ka21 * p))) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

  g11 <- -((a0 * (-1 + ka10) * ka11 *(-1 + ka20) * ka21 * (-1 + p) * p * p) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p)))

  g10 <- ((-1 + ka10) * ka11 * (-1 + p) * p * (ka20 + (ka21 - a0 * ka21 + ka20 * (-1 + a0 * ka21)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

  g01 <- ((-1 + ka20) * ka21 * (-1 + p) * p * (ka10 + (ka11 - a0 * ka11 + ka10 *(-1 + a0 * ka11)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

  g00 <- -((-1 + p) *  (ka10 * ka20 + ka10 * ka20 * (-2 + ka11 + ka21) * p + (-ka10 * (-1 + ka11) * ka20 + (-ka10 * ka20 + ka11 * (-1 + ka10 + a0 * (-1 + ka10) * (-1 + ka20) + ka20)) * ka21) * p * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

  y11 <- u11 * f11 / (f11 + g11)
  y10 <- u10 * f10 / (f10 + g10)
  y01 <- u01 * f01 / (f01 + g01)
  y00 <- u00 * f00 / (f00 + g00)
  y <- y11 + y10 + y01 + y00
    
  emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
  emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
    
  emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
  emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
  
  emp <- (ss + y) / n
    
  ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
  ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
  
  vec1 <- vector()
  vec2 <- vector()
  vec3 <- vector()
  vec4 <- vector()
  vec5 <- vector()
  vec6 <- vector()
  vec7 <- vector()  
  
  vec1[1] <- (emka10 - ka10) / (x - a1)
  vec2[1] <- (emka11 - ka11) / (x - a1)
  vec3[1] <- (emka20 - ka20) / (x - a1)
  vec4[1] <- (emka21 - ka21) / (x - a1)
  vec5[1] <- (emp - p) / (x - a1)
  vec6[1] <- (ema1 - a1) / (x - a1)
  vec7[1] <- (ema0 - a0) / (x - a1)            
            
  j <- 1
    
  while (j <= length(cov1))
    {
      j <- j + 1
      
      x <- cov1[j]
  
      f11 <- (x * p * (ka10 * ka11 *(1 - p) + ka11 * p) * (ka20 * ka21 * (1 - p) + ka21  * p)) / ((ka10 * (1 - p) + ka11 * p) * (ka20 * (1 - p) + ka21 * p))

      f10 <- (ka11 * p * (ka10 + p - ka10 * p) * (1 + (x *  ka21 * (ka20 + p - ka20 * p)) / (ka20 * (-1 + p) - ka21 * p))) / (ka10 - ka10 * p + ka11 * p)
  
      f01 <- (ka21 * p * (ka20 + p - ka20 * p) * (1 + (x * ka11 * (ka10 + p - ka10 * p))/(ka10 * (-1 + p) - ka11 * p)))/(ka20 - ka20 * p + ka21 * p)
  
      f00 <- (p  * (-(-1 + x) * ka11 * ka21 * (ka20 * (-1 + p) - p) * p + ka10 * (-1 + p) * (ka20 * (1 - ka11 - ka21 + x * ka11 * ka21) * (-1 + p) - (-1 + x)* ka11 * ka21 * p))) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
  
      g11 <- -((a0 * (-1 + ka10) * ka11 *(-1 + ka20) * ka21 * (-1 + p) * p * p) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p)))
  
      g10 <- ((-1 + ka10) * ka11 * (-1 + p) * p * (ka20 + (ka21 - a0 * ka21 + ka20 * (-1 + a0 * ka21)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
  
      g01 <- ((-1 + ka20) * ka21 * (-1 + p) * p * (ka10 + (ka11 - a0 * ka11 + ka10 *(-1 + a0 * ka11)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
  
      g00 <- -((-1 + p) *  (ka10 * ka20 + ka10 * ka20 * (-2 + ka11 + ka21) * p + (-ka10 * (-1 + ka11) * ka20 + (-ka10 * ka20 + ka11 * (-1 + ka10 + a0 * (-1 + ka10) * (-1 + ka20) + ka20)) * ka21) * p * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

      y11 <- u11 * f11 / (f11 + g11)
      y10 <- u10 * f10 / (f10 + g10)
      y01 <- u01 * f01 / (f01 + g01)
      y00 <- u00 * f00 / (f00 + g00)
      y <- y11 + y10 + y01 + y00
        
      emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
      emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
        
      emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
      emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
      
      emp <- (ss + y) / n
        
      ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
      ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
      
      if (x - a1 == 0) break
    
      vec1[j] <- (emka10 - ka10) / (x - a1)
      vec2[j] <- (emka11 - ka11) / (x - a1)
      vec3[j] <- (emka20 - ka20) / (x - a1)
      vec4[j] <- (emka21 - ka21) / (x - a1)
      vec5[j] <- (emp - p) / (x - a1)
      vec6[j] <- (ema1 - a1) / (x - a1)
      vec7[j] <- (ema0 - a0) / (x - a1)                    
    } 
  
  for(j in 2:length(vec1)) 
    {  
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) 
      {
        b61 <- vec1[j]
      }
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec2)) 
    {  
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) 
      {
        b62 <- vec2[j]
      }
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec3)) 
    {  
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) 
      {
        b63 <- vec3[j]
      }
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec4)) 
    {  
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) 
      {
        b64 <- vec4[j]
      }
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec5)) 
    {  
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) 
      {
        b65 <- vec5[j]
      }
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec6)) 
    {  
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) 
      {
        b66 <- vec6[j]
      }
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec7)) 
    {  
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) 
      {
        b67 <- vec7[j]
      }
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) break 
    }
  
  
  # Matrix DM: r7j
  
  x <- cov0[1]
  
  f11 <- (a1 * p * (ka10 * ka11 *(1 - p) + ka11 * p) * (ka20 * ka21 * (1 - p) + ka21  * p)) / ((ka10 * (1 - p) + ka11 * p) * (ka20 * (1 - p) + ka21 * p))

  f10 <- (ka11 * p * (ka10 + p - ka10 * p) * (1 + (a1 *  ka21 * (ka20 + p - ka20 * p)) / (ka20 * (-1 + p) - ka21 * p))) / (ka10 - ka10 * p + ka11 * p)

  f01 <- (ka21 * p * (ka20 + p - ka20 * p) * (1 + (a1 * ka11 * (ka10 + p - ka10 * p))/(ka10 * (-1 + p) - ka11 * p)))/(ka20 - ka20 * p + ka21 * p)

  f00 <- (p  * (-(-1 + a1) * ka11 * ka21 * (ka20 * (-1 + p) - p) * p + ka10 * (-1 + p) * (ka20 * (1 - ka11 - ka21 + a1 * ka11 * ka21) * (-1 + p) - (-1 + a1)* ka11 * ka21 * p))) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

  g11 <- -((x * (-1 + ka10) * ka11 *(-1 + ka20) * ka21 * (-1 + p) * p * p) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p)))

  g10 <- ((-1 + ka10) * ka11 * (-1 + p) * p * (ka20 + (ka21 - x * ka21 + ka20 * (-1 + x * ka21)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

  g01 <- ((-1 + ka20) * ka21 * (-1 + p) * p * (ka10 + (ka11 - x * ka11 + ka10 *(-1 + x * ka11)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

  g00 <- -((-1 + p) *  (ka10 * ka20 + ka10 * ka20 * (-2 + ka11 + ka21) * p + (-ka10 * (-1 + ka11) * ka20 + (-ka10 * ka20 + ka11 * (-1 + ka10 + x * (-1 + ka10) * (-1 + ka20) + ka20)) * ka21) * p * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
  
  y11 <- u11 * f11 / (f11 + g11)
  y10 <- u10 * f10 / (f10 + g10)
  y01 <- u01 * f01 / (f01 + g01)
  y00 <- u00 * f00 / (f00 + g00)
  y <- y11 + y10 + y01 + y00
    
  emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
  emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
    
  emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
  emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
  
  emp <- (ss + y) / n
    
  ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
  ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
  
  vec1 <- vector()
  vec2 <- vector()
  vec3 <- vector()
  vec4 <- vector()
  vec5 <- vector()
  vec6 <- vector()
  vec7 <- vector()  
  
  vec1[1] <- (emka10 - ka10) / (x - a0)
  vec2[1] <- (emka11 - ka11) / (x - a0)
  vec3[1] <- (emka20 - ka20) / (x - a0)
  vec4[1] <- (emka21 - ka21) / (x - a0)
  vec5[1] <- (emp - p) / (x - a0)
  vec6[1] <- (ema1 - a1) / (x - a0)
  vec7[1] <- (ema0 - a0) / (x - a0)            
            
  j <- 1
    
  while (j <= length(cov0))
    {
      j <- j + 1
      
      x <- cov0[j]
  
      f11 <- (a1 * p * (ka10 * ka11 *(1 - p) + ka11 * p) * (ka20 * ka21 * (1 - p) + ka21  * p)) / ((ka10 * (1 - p) + ka11 * p) * (ka20 * (1 - p) + ka21 * p))

      f10 <- (ka11 * p * (ka10 + p - ka10 * p) * (1 + (a1 *  ka21 * (ka20 + p - ka20 * p)) / (ka20 * (-1 + p) - ka21 * p))) / (ka10 - ka10 * p + ka11 * p)
  
      f01 <- (ka21 * p * (ka20 + p - ka20 * p) * (1 + (a1 * ka11 * (ka10 + p - ka10 * p))/(ka10 * (-1 + p) - ka11 * p)))/(ka20 - ka20 * p + ka21 * p)
  
      f00 <- (p  * (-(-1 + a1) * ka11 * ka21 * (ka20 * (-1 + p) - p) * p + ka10 * (-1 + p) * (ka20 * (1 - ka11 - ka21 + a1 * ka11 * ka21) * (-1 + p) - (-1 + a1)* ka11 * ka21 * p))) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
  
      g11 <- -((x * (-1 + ka10) * ka11 *(-1 + ka20) * ka21 * (-1 + p) * p * p) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p)))
  
      g10 <- ((-1 + ka10) * ka11 * (-1 + p) * p * (ka20 + (ka21 - x * ka21 + ka20 * (-1 + x * ka21)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
  
      g01 <- ((-1 + ka20) * ka21 * (-1 + p) * p * (ka10 + (ka11 - x * ka11 + ka10 *(-1 + x * ka11)) * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))
  
      g00 <- -((-1 + p) *  (ka10 * ka20 + ka10 * ka20 * (-2 + ka11 + ka21) * p + (-ka10 * (-1 + ka11) * ka20 + (-ka10 * ka20 + ka11 * (-1 + ka10 + x * (-1 + ka10) * (-1 + ka20) + ka20)) * ka21) * p * p)) / ((ka10 * (-1 + p) - ka11 * p) * (ka20 * (-1 + p) - ka21 * p))

      y11 <- u11 * f11 / (f11 + g11)
      y10 <- u10 * f10 / (f10 + g10)
      y01 <- u01 * f01 / (f01 + g01)
      y00 <- u00 * f00 / (f00 + g00)
      y <- y11 + y10 + y01 + y00
    
      emka10 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((r + u - y) * (n10 + n11))
      emka11 <- ((s10 + y10 + s11 + y11) * (r00 + u00 - y00 + r01 + u01 - y01) - (s00 + y00 + s01 + y01) * (r10 + u10 - y10 + r11 + u11 - y11)) / ((ss + y) * (n00 + n01))
        
      emka20 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((r + u - y) * (n01 + n11))
      emka21 <- ((s01 + y01 + s11 + y11) * (r00 + u00 - y00 + r10 + u10 - y10) - (s00 + y00 + s10 + y10) * (r01 + u01 - y01 + r11 + u11 - y11)) / ((ss + y) * (n00 + n10))
      
      emp <- (ss + y) / n
        
      ema1 <- (ss + y) * (s11 + y11) / ((s01 + y01 + s11 + y11) * (s10 + y10 + s11 + y11)) 
      ema0 <- (r + u - y) * (r11 + u11 - y11) / ((r01 + u01 - y01 + r11 + u11 - y11) * (r10 + u10 - y10 + r11 + u11 - y11))
  
      if (x - a0 == 0) break
    
      vec1[j] <- (emka10 - ka10) / (x - a0)
      vec2[j] <- (emka11 - ka11) / (x - a0)
      vec3[j] <- (emka20 - ka20) / (x - a0)
      vec4[j] <- (emka21 - ka21) / (x - a0)
      vec5[j] <- (emp - p) / (x - a0)
      vec6[j] <- (ema1 - a1) / (x - a0)
      vec7[j] <- (ema0 - a0) / (x - a0) 
                       
    }
  
  for(j in 2:length(vec1)) 
    {  
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) 
      {
        b71 <- vec1[j]
      }
    if (abs(vec1[j] - vec1[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec2)) 
    {  
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) 
      {
        b72 <- vec2[j]
      }
    if (abs(vec2[j] - vec2[j-1]) <= sqrtdelta) break 
    }
  
  for(j in 2:length(vec3)) 
    {  
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) 
      {
        b73 <- vec3[j]
      }
    if (abs(vec3[j] - vec3[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec4)) 
    {  
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) 
      {
        b74 <- vec4[j]
      }
    if (abs(vec4[j] - vec4[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec5)) 
    {  
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) 
      {
        b75 <- vec5[j]
      }
    if (abs(vec5[j] - vec5[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec6)) 
    {  
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) 
      {
        b76 <- vec6[j]
      }
    if (abs(vec6[j] - vec6[j-1]) <= sqrtdelta) break 
    }
    
  for(j in 2:length(vec7)) 
    {  
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) 
      {
        b77 <- vec7[j]
      }
    if (abs(vec7[j] - vec7[j-1]) <= sqrtdelta) break 
    }

  remove(vec1)
  remove(vec2)
  remove(vec3)
  remove(vec4)
  remove(vec5)
  remove(vec6)
  remove(vec7)
  
  dm <- matrix(0, 7, 7, dimnames = list(c("Kappa10", "Kappa11", "Kappa20", "Kappa21", "p", "a1", "a0"), c("Kappa10", "Kappa11", "Kappa20", "Kappa21", "p", "a1", "a0")))
   
  dm[1,1] <- b11
  dm[1,2] <- b12
  dm[1,3] <- b13
  dm[1,4] <- b14
  dm[1,5] <- b15
  dm[1,6] <- b16
  dm[1,7] <- b17
  
  dm[2,1] <- b21
  dm[2,2] <- b22
  dm[2,3] <- b23
  dm[2,4] <- b24
  dm[2,5] <- b25
  dm[2,6] <- b26
  dm[2,7] <- b27
  
  dm[3,1] <- b31
  dm[3,2] <- b32
  dm[3,3] <- b33
  dm[3,4] <- b34
  dm[3,5] <- b35
  dm[3,6] <- b36
  dm[3,7] <- b37
  
  dm[4,1] <- b41
  dm[4,2] <- b42
  dm[4,3] <- b43
  dm[4,4] <- b44
  dm[4,5] <- b45
  dm[4,6] <- b46
  dm[4,7] <- b47
  
  dm[5,1] <- b51
  dm[5,2] <- b52
  dm[5,3] <- b53
  dm[5,4] <- b54
  dm[5,5] <- b55
  dm[5,6] <- b56
  dm[5,7] <- b57
  
  dm[6,1] <- b61
  dm[6,2] <- b62
  dm[6,3] <- b63
  dm[6,4] <- b64
  dm[6,5] <- b65
  dm[6,6] <- b66
  dm[6,7] <- b67
  
  dm[7,1] <- b71
  dm[7,2] <- b72
  dm[7,3] <- b73
  dm[7,4] <- b74
  dm[7,5] <- b75
  dm[7,6] <- b76
  dm[7,7] <- b77
  
  
  # Variance-covariance matrix
   
  id <- diag(7)
  
  invfis <- solve(fis)   # Inverse matrix of Fisher matrix
      
  sigma <- invfis %*% solve(id - dm) # Variance-covariance matrix
  
  sigmakappa <- sigma[-6:-7, -6:-7]  # Variance-covarianece matrix of the weighted kappa coefficients and prevalence
    
  if(p == Q1) averagekappa11 <- expression(((p * ka11 + (1 - p) * ka10 * ka11) / ((1 - p) * ka10 + p * ka11)) + (((1 - p) * ka10 + p * ka10 * ka11) / ((1 - p) * ka10 + p * ka11)) - 1)
  else averagekappa11 <- expression((2 * ka10 * ka11 / (ka10 - ka11)) * log((ka10 + ka11) / (2 * ka11)))  
    
  if(p == Q2) averagekappa21 <- expression(((p * ka21 + (1 - p) * ka20 * ka21) / ((1 - p) * ka20 + p * ka21)) + (((1 - p) * ka20 + p * ka20 * ka21) / ((1 - p) * ka20 + p * ka21)) -1)
  else averagekappa21 <- expression((2 * ka20 * ka21 / (ka20 - ka21)) * log((ka20 + ka21) / (2 * ka21)))     
  
  if(p == Q1) averagekappa12 <- expression(((p * ka11 + (1 - p) * ka10 * ka11) / ((1 - p) * ka10 + p * ka11)) + (((1 - p) * ka10 + p * ka10 * ka11) / ((1 - p) * ka10 + p * ka11)) - 1) 
  else averagekappa12 <- expression((2 * ka10 * ka11 / (ka10 - ka11)) * log((2 * ka10) / (ka10 + ka11))) 
  
  if(p == Q2) averagekappa22 <- expression(((p * ka21 + (1 - p) * ka20 * ka21) / ((1 - p) * ka20 + p * ka21)) + (((1 - p) * ka20 + p * ka20 * ka21) / ((1 - p) * ka20 + p * ka21)) -1)
  else averagekappa22 <- expression((2 * ka20 * ka21 / (ka20 - ka21)) * log((2 * ka20) / (ka20 + ka21))) 
  
  deriakc111 <- D(averagekappa11,"ka10")
  deriakc112 <- D(averagekappa11,"ka11")
  deriakc113 <- D(averagekappa11,"ka20")
  deriakc114 <- D(averagekappa11,"ka21")
  deriakc115 <- D(averagekappa11,"p")
  
  deriakc211 <- D(averagekappa21,"ka10")
  deriakc212 <- D(averagekappa21,"ka11")
  deriakc213 <- D(averagekappa21,"ka20")
  deriakc214 <- D(averagekappa21,"ka21")
  deriakc215 <- D(averagekappa21,"p")
  
  matderi1 <- matrix(0, 2, 5)
  
  matderi1[1,1] <- - eval(deriakc111)
  matderi1[1,2] <- - eval(deriakc112)
  matderi1[1,3] <- - eval(deriakc113)
  matderi1[1,4] <- - eval(deriakc114)
  matderi1[1,5] <- - eval(deriakc115)
  
  matderi1[2,1] <- - eval(deriakc211)
  matderi1[2,2] <- - eval(deriakc212)
  matderi1[2,3] <- - eval(deriakc213)
  matderi1[2,4] <- - eval(deriakc214)
  matderi1[2,5] <- - eval(deriakc215)
  
  deriakc121 <- D(averagekappa12,"ka10")
  deriakc122 <- D(averagekappa12,"ka11")
  deriakc123 <- D(averagekappa12,"ka20")
  deriakc124 <- D(averagekappa12,"ka21")
  deriakc125 <- D(averagekappa12,"p")
  
  deriakc221 <- D(averagekappa22,"ka10")
  deriakc222 <- D(averagekappa22,"ka11")
  deriakc223 <- D(averagekappa22,"ka20")
  deriakc224 <- D(averagekappa22,"ka21")
  deriakc225 <- D(averagekappa22,"p")
  
  matderi2 <- matrix(0, 2, 5)
  
  matderi2[1,1] <- - eval(deriakc121)
  matderi2[1,2] <- - eval(deriakc122)
  matderi2[1,3] <- - eval(deriakc123)
  matderi2[1,4] <- - eval(deriakc124)
  matderi2[1,5] <- - eval(deriakc125)
  
  matderi2[2,1] <- - eval(deriakc221)
  matderi2[2,2] <- - eval(deriakc222)
  matderi2[2,3] <- - eval(deriakc223)
  matderi2[2,4] <- - eval(deriakc224)
  matderi2[2,5] <- - eval(deriakc225)
  
  matvar1 <- matrix(0, 2, 2, dimnames = list(c("Average kappa11", "Average kappa21"), c("Average kappa11", "Average kappa21")))
  
  matvar1 <- matderi1 %*% sigmakappa %*% t(matderi1)
  
  z1 <- abs(averageka11 - averageka21) / sqrt(matvar1[1, 1] + matvar1[2, 2] - 2 * matvar1[1, 2])
  
  pvalue1 <- 2 * (1 - pnorm(z1, 0, 1))
  
  Laverageka1 <- averageka11 - averageka21 - zalpha * sqrt(matvar1[1, 1] + matvar1[2, 2] - 2 * matvar1[1, 2])
  Uaverageka1 <- averageka11 - averageka21 + zalpha * sqrt(matvar1[1, 1] + matvar1[2, 2] - 2 * matvar1[1, 2])
  
  matvar2 <- matrix(0, 2, 2, dimnames = list(c("Average kappa12", "Average kappa22"), c("Average kappa12", "Average kappa22")))
  
  matvar2 <- matderi2 %*% sigmakappa %*% t(matderi2)
  
  z2 <- abs(averageka12 - averageka22) / sqrt(matvar2[1, 1] + matvar2[2, 2] - 2 * matvar2[1, 2])
  
  pvalue2 <- 2 * (1 - pnorm(z2, 0, 1))
  
  Laverageka2 <- averageka12 - averageka22 - zalpha * sqrt(matvar2[1, 1] + matvar2[2, 2] - 2 * matvar2[1, 2])
  Uaverageka2 <- averageka12 - averageka22 + zalpha * sqrt(matvar2[1, 1] + matvar2[2, 2] - 2 * matvar2[1, 2]) 
 
 # Results
 
  cat("\n") 
  cat("\n") 
  cat("          COMPARISON OF AVERAGE KAPPA COEFFICIENTS OF TWO BDTS WITH MISSING DATA: EM AND SEM ALGORITHMS \n")
  cat("\n")
  cat("\n")
  cat("Iterations of the EM algorithm: ", i, "\n")       
  cat("\n")
  cat("\n") 
  cat("Inverse matrix of the Fisher information matrix for complete data: ", "\n")
  print(invfis)
  cat("\n")
  cat("\n")
  cat("DM matrix: ", "\n")
  print(dm)
  cat("\n")
  cat("\n")
  cat("Variance-covariance matrix of weighted kappa coefficients, prevalence and covariances: ", "\n")
  print(sigma)
  cat("\n")
  cat("\n")     
  cat("Estimated weighted kappa coefficient K(0) of Test 1 is ", ka10, " and its standard error is ", sqrt(sigmakappa[1,1]), "\n")       
  cat("\n") 
  cat("Estimated weighted kappa coefficient K(1) of Test 1 is ", ka11, " and its standard error is ", sqrt(sigmakappa[2,2]), "\n")    
  cat("\n")
  cat("Estimated weighted kappa coefficient K(0) of Test 2 is ", ka20, " and its standard error is ", sqrt(sigmakappa[3,3]), "\n")    
  cat("\n") 
  cat("Estimated weighted kappa coefficient K(1) of Test 2 is ", ka21, " and its standard error is ", sqrt(sigmakappa[4,4]), "\n")
  cat("\n")
  cat("Estimated disease prevalence is ", p, " and its standard error is ", sqrt(sigmakappa[5,5]), "\n")       
  cat("\n")
  cat("Estimated covariance a1 is ", a1, "\n")       
  cat("\n")
  cat("Estimated covariance a0 is ", a0, "\n")       
  cat("\n")
  cat("\n")    
  cat("     COMPARISON OF AVERAGE KAPPA COEFFICIENTS FOR  L' > L  (0 < c < 0.5) \n")
  cat("\n")
  cat("Variance-covariance matrix: ", "\n")
  print(matvar1)
  cat("\n")         
  cat("Estimated average kappa coefficient of Test 1 is ",averageka11," and its standard error is", sqrt(matvar1[1, 1]), "\n")       
  cat("\n") 
  cat("Estimated average kappa coefficient of Test 2 is ",averageka21," and its standard error is", sqrt(matvar1[2, 2]), "\n")  
  cat("\n")  
  cat("Test Statistic for the hypothesis test is ", z1, " and the p-value is ", pvalue1, "\n")
  cat("\n") 
  cat(100 * conf, "% confidence interval for the difference between the two average kappa coefficients is: ", Laverageka1," ; ", Uaverageka1, "\n")
  cat("\n")
  cat("\n")    
  cat("     COMPARISON OF AVERAGE KAPPA COEFFICIENTS FOR  L > L'  (0.5 < c < 1) \n")
  cat("\n")
  cat("Variance-covariance matrix: ", "\n")
  print(matvar2)
  cat("\n")         
  cat("Estimated average kappa coefficient of Test 1 is ",averageka12," and its standard error is", sqrt(matvar2[1, 1]), "\n")       
  cat("\n") 
  cat("Estimated average kappa coefficient of Test 2 is ",averageka22," and its standard error is", sqrt(matvar2[2, 2]), "\n")  
  cat("\n")  
  cat("Test Statistic for the hypothesis test is ", z2, " and the p-value is ", pvalue2, "\n")
  cat("\n") 
  cat(100 * conf, "% confidence interval for the difference between the two average kappa coefficients is: ", Laverageka2," ; ", Uaverageka2, "\n")
  cat("\n")

}